using UnityEngine;

namespace Damage
{
    public class Mod
    {
        public static bool spawnerEnabled = true;
        public static bool zombieBites = true;
        public static bool restrictedReconstructor = false;
        public static bool preventCorruption = true;
        public static PhysicalProperties humanProperties;

        public static void Main()
        {
            ModAPI.RegisterLiquid(UltraStrengthOrganSyringe.UltraStrengthOrganSerumLiquid.ID, new UltraStrengthOrganSyringe.UltraStrengthOrganSerumLiquid());
            ModAPI.RegisterLiquid(ZombieOrganSyringe.ZombiePoisonOrganLiquid.ID, new ZombieOrganSyringe.ZombiePoisonOrganLiquid());
            ModAPI.Register<SpawnBehaviour>();

            ModAPI.OnItemSpawned += (sender, obj) =>
            {
                GameObject gameObj = obj.Instance;
                PersonBehaviour person = gameObj.GetComponent<PersonBehaviour>();
                LimbBehaviour limb = gameObj.GetComponent<LimbBehaviour>();
                if (spawnerEnabled)
                {
                    if (person)
                    {
                        if (person.Limbs[0].SpeciesIdentity != "Human")
                            return;
                        GameObject shock = new GameObject();
                        shock.transform.parent = obj.Instance.transform;
                        shock.AddComponent<Optout>();
                        ShockBehaviour shockBehaviour = shock.AddComponent<ShockBehaviour>();
                        shockBehaviour.person = person;
                        foreach (LimbBehaviour limbBehaviour in person.Limbs)
                        {
                            if (!limbBehaviour.gameObject.GetComponent<HumanDamageBehaviour>())
                            {
                                limbBehaviour.gameObject.AddComponent<HumanDamageBehaviour>();
                                limbBehaviour.PhysicalBehaviour.Properties = humanProperties;
                            }
                            limbBehaviour.GetComponent<HumanDamageBehaviour>().shockBehaviour = shockBehaviour;
                        }
                    }
                    if (gameObj.TryGetComponent(out HealthGunBehaviour health))
                    {
                        HealthGunOrganBehaviour gun = obj.Instance.AddComponent<HealthGunOrganBehaviour>();
                        gun.range = health.range;
                        gun.offset = health.offset;
                        gun.PhysicalBehaviour = health.PhysicalBehaviour;
                        gun.ShotSounds = health.ShotSounds;
                        gun.Muzzleflash = health.Muzzleflash;
                        gun.barrelPosition = health.barrelPosition;
                        gun.barrelDirection = health.barrelDirection;
                        Object.Destroy(health);
                    }
                    if (gameObj.TryGetComponent(out UltraStrengthSyringe strength))
                    {
                        UltraStrengthOrganSyringe syringe = obj.Instance.AddComponent<UltraStrengthOrganSyringe>();
                        Object.Destroy(strength);
                    }
                    if (gameObj.TryGetComponent(out ZombieSyringe zombie))
                    {
                        ZombieOrganSyringe syringe = obj.Instance.AddComponent<ZombieOrganSyringe>();
                        Object.Destroy(zombie);
                    }
                }
            };
        }
    }
}