using System.Collections;
using UnityEngine;

namespace Damage
{
    public class SpawnBehaviour : MonoBehaviour
    {
        public bool spawnerEnabled = true;
        int i;
        
        void Start()
        {
            ModAPI.Notify("Advanced Damage added! Double press M to enable or disable applying the script to spawned humans.");
            StartCoroutine("DoublePress");

            PhysicalProperties prop = Instantiate(ModAPI.FindPhysicalProperties("Human"));

            prop.BulletSpeedAbsorptionPower = 1f;

            Mod.humanProperties = prop;
        }
        void Update()
        {
            if (Input.GetKeyDown(KeyCode.M))
            {
                i++;
                if (i >= 2)
                {
                    if (Mod.spawnerEnabled)
                    {
                        ModAPI.Notify("Automatic applying disabled!");
                        Mod.spawnerEnabled = false;
                    }
                    else
                    {
                        ModAPI.Notify("Automatic applying enabled!");
                        Mod.spawnerEnabled = true;
                    }
                    i = 0;
                }
            }
        }
        private IEnumerator DoublePress()
        {
            while (true)
            {
                i = 0;
                yield return new WaitForSeconds(1f);
            }
        }
    }
}